
public class KUNDENWARTESCHLANGE_TESTER
{
    private KUNDENWARTESCHLANGE ts;
    

    
    public KUNDENWARTESCHLANGE_TESTER()
    {
        // Schlange der Länge 3 erzeugen
        
        System.out.println("TEST startet: ------------------------");
        System.out.println();
        this.ts = new KUNDENWARTESCHLANGE(3);
        System.out.println("Neue Kundenschlange der Länge 3 erzeugt");
        if ( this.ts.istLeer() ) {
            System.out.println("Die Schlange ist leer");
        }
        else {
            System.out.println("FEHLER bei Methode'istLeer()' !!!");
        }
        System.out.println();
        
        // 3 Kunden erzeugen und einreihen
        
        System.out.println("--- Erzeuge 3 Kunden und reihe sie ein:");
        System.out.println();
        
        boolean b0 = true;
        KUNDE t1 = new KUNDE("Kunde 1");
        System.out.println("Neuer KUNDE 'Kunde 1' erzeugt");
        boolean b1 = this.ts.hintenEinreihen(t1);
        if (b1) {
            System.out.println("KUNDE 'Kunde 1' hinten eingereiht");
        }
        else {
            System.out.println("Einreihen von Kunde 1 FEHLGESCHLAGEN !!!");
        }
        if ( this.ts.nenneAnzahl() == 1 ) {
            System.out.println("Es ist 1 Kunde in der Schlange");
        }
        else {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
            b0 = false;
        }
        System.out.println();
        
        KUNDE t2 = new KUNDE("Kunde 2");
        System.out.println("Neuer Kunde 2 erzeugt");
        boolean b2 = this.ts.hintenEinreihen(t2);
        if (b2) {
            System.out.println("KUNDE 'Kunde 2' hinten eingereiht");
        }
        else {
            System.out.println("Einreihen von Kunde 2 FEHLGESCHLAGEN !!!");
        }
        if ( this.ts.nenneAnzahl() == 2 ) {
            System.out.println("Es sind 2 Kunden in der Schlange");
        }
        else {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
            b0 = false;
        }
        System.out.println();
        
        KUNDE t3 = new KUNDE("Kunde 3");
        System.out.println("Neuer KUNDE 'Kunde 3' erzeugt");
        boolean b3 = this.ts.hintenEinreihen(t3);
        if (b3) {
            System.out.println("KUNDE 'Kunde 3' hinten eingereiht");
        }
        else {
            System.out.println("Einreihen von Kunde 3 FEHLGESCHLAGEN !!!");
        }
        if ( this.ts.nenneAnzahl() == 3 ) {
            System.out.println("Es sind 3 Kunden in der Schlange");
        }
        else {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
            b0 = false;
        }
        System.out.println();
        
        // weiteres KUNDE in volle Schlange einreihen
        
        System.out.println("--- Versuche einen Kunden zu viel einzureihen:");
        System.out.println();
        
        KUNDE t4 = new KUNDE("Kunde 4");
        System.out.println("Neuer Kunde 4 erzeugt");
        boolean b4 = this.ts.hintenEinreihen(t4);
        if (b4) {
            System.out.println("FEHLER bei voller Schlange !!!");
        }
        else {
            System.out.println("Schlange voll, Kunde 4 kann nicht eingereiht werden");
        }
        boolean b5 = true;
        if ( this.ts.nenneAnzahl() != 3 ) {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
            b5 = false;
        }
        System.out.println();
        
        
        System.out.println("--- Kunden wieder entnehmen:");
        System.out.println();
        
        t1 = this.ts.vorneEntnehmen();
        boolean b6 = t1.nenneName().equals("Kunde 1");
        if (b6) {
            System.out.println("Kunde mit Namen 'Kunde 1' entnommen");
        }
        else {
            System.out.println("FEHLER !!! Kunde mit Namen '" + t1.nenneName() + "' entnommen");
        }
        if ( this.ts.nenneAnzahl() != 2) {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
        }
        System.out.println();
        
        t2 = this.ts.vorneEntnehmen();
        boolean b7 = t2.nenneName().equals("Kunde 2");
        if (b7) {
            System.out.println("Kunde mit Namen 'Kunde 2' entnommen");
        }
        else {
            System.out.println("FEHLER !!! Kunde mit Namen '" + t2.nenneName() + "' entnommen");
        }
        if ( this.ts.nenneAnzahl() != 1) {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
        }
        System.out.println();
        
        t3 = this.ts.vorneEntnehmen();
        boolean b8 = t3.nenneName().equals("Kunde 3");
        if (b8) {
            System.out.println("Kunde mit Namen 'Kunde 3' entnommen");
        }
        else {
            System.out.println("FEHLER !!! Kunde mit Namen '" + t3.nenneName() + "' entnommen");
        }
        boolean b9 = true;
        if ( this.ts.nenneAnzahl() != 0) {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
            b9 = false;
        }
        System.out.println();
        
        if ( !this.ts.istLeer() ) {
            System.out.println("FEHLER bei Methode 'istLeer()' !!!");
            b9 = false;
        }
        else {
            System.out.println("Die Schlange ist leer");
        }
        System.out.println();
        
        // Versuch, KUNDE aus leerer Schlange zu entnehmen
        
        System.out.println("--- Versuche Kunden aus leerer Schlange zu entnehmen:");
        System.out.println();
        
        t4 = this.ts.vorneEntnehmen();
        boolean b10 = true;
        if ( t4 == null ) {
            System.out.println("Kann kein Kunden aus leerer Schlange entnehmen");
        }
        else {
            System.out.println("FEHLER beim Entnehmen aus leerer Schlange !!!");
            b10 = false;
        }
        if ( this.ts.nenneAnzahl() == 0 ) {
            System.out.println("Die Schlange ist und bleibt leer");
        }
        else {
            System.out.println("FEHLER bei Methode 'nenneAnzahl()' !!!");
            b10 = false;
        }
        System.out.println();
        
        // Zusammenfassung
        
        System.out.println("---------------------------------------");
        System.out.println("Zusammenfassung:");
        System.out.println();
        if (b0 && b1 && b2 && b3) {
            System.out.println("Einreihen fehlerfrei    :-)");
        }
        else {
            System.out.println("FEHLER beim Einreihen der KUNDEn    :-(");
        }
        if (!b4 && b5) {
            System.out.println("Überladen der Schlange nicht möglich    :-)");
        }
        else {
            System.out.println("FEHLER beim Überladen der Schlange    :-(");
        }
        if (b6 && b7 && b8 && b9) {
            System.out.println("Entnehmen fehlerfrei    :-)");
        }
        else {
            System.out.println("FEHLER beim Entnehmen der KUNDEn    :-(");
        }
        if (b10) {
            System.out.println("Entnehmen bei leerer Schlange nicht möglich    :-)");
        }
        else {
            System.out.println("FEHLER beim Entnehmen aus leerer Schlange    :-(");
        }
    }
    
    
    
}
